c*******************************************************************
c* PREDPM                                                          *
c* Short description                                               *
c*   Pre-calculation of data needed by dpm.f                       *
c*                                                                 *
c* Copyright (c) 2000,2001                                         *
c* The University of Barcelona                                     *
c*                                                                 *
c* Permission to use, copy, modify, distribute and sell this       *
c* software and its documentation for any purpose is hereby granted*
c* without fee, provided that the above copyright notice appear in *
c* all copies and that both that copyright notice and this         *
c* permission notice appear in supporting documentation.  The      *
c* University of Barcelona makes no representations about the      *
c* suitability of this software for any purpose. It is provided    *
c* "as is" without express or implied warranty.                    *
c*                                                                 *
c* Copyright (c) 2000,2001                                         *
c* Polytechnical University of Catalonia                           *
c*                                                                 *
c* Permission to use, copy, modify, distribute and sell this       *
c* software and its documentation for any purpose is hereby granted*
c* without fee, provided that the above copyright notice appear in *
c* all copies and that both that copyright notice and this         *
c* permission notice appear in supporting documentation.  The      *
c* Polytechnical University of Catalonia makes no representations  *
c* about the suitability of this software for any purpose. It is   *
c* provided "as is" without express or implied warranty.           *
c*                                                                 *
c* Copyright (c) 2000,2001                                         *
c* The University of Michigan                                      *
c*                                                                 *
c* Permission to use, copy, modify, distribute and sell this       *
c* software and its documentation for any purpose is hereby granted*
c* without fee, provided that the above copyright notice appear in *
c* all copies and that both that copyright notice and this         *
c* permission notice appear in supporting documentation.  The      *
c* University of Michigan makes no representations about the       *
c* suitability of this software for any purpose. It is provided    *
c* "as is" without express or implied warranty.                    *
c*                                                                 *
c* Last update                                                     *
c*   2001-02-14 JS. Adapted to FUEL.                               *
c*   1999-09-23 SW.                                                *
c*   1998-04-12 JS. Created                                        *
c*******************************************************************
      program main
      implicit none
      character*20 prefix
      integer len
      common /cid/ prefix,len
      real*8 emin,emax,einf,esup,epinf,epsup,eminph
      common /elimit/ emin,emax,eminph,einf,esup,epinf,epsup
      real*8 shigh,slow,ecross
      common /dpmpat/ shigh,slow,ecross

      character*100 buffer
      character*20 matnam
      character*40 fname
      character*6 suffix(11)
      data suffix/'matter','scpw','rstpw','lamph','compt','phote',
     &            'pairp','brecon','lambre','bw','q'/
      integer granul,nomat,i,iounit,len2
      integer*4 bytes
      parameter (granul=1)
      real*8 wcc,wcb,mass,atno,atno2,excite
      real*8 dens,refzm,refz2m,absmin,atno21
      parameter (absmin=100.0d0)

      read(*,*) buffer
      read(*,*) buffer
      call getnam(5,prefix,len)

c     *** Open output units (using odd numbers for output):
      write(*,*) ' '
      do 5 i=1,11
        iounit = 11 + (i-1)*2
        fname = prefix(1:len)//'.'//suffix(i)
        open(iounit,file=fname)
        write(*,*) 'main: ',fname,' opened as unit ',iounit
        write(iounit,*) 'This file is part of set:'
        write(iounit,*) prefix(1:len)
 5    continue
      write(*,*) ' '

c     *** Read configuration:
      write(11,*) 'HEADER section: Material data file for DPM.'
      read(*,'(a100)') buffer
      write(11,*) buffer
      read(*,*) eminph,emin,emax
      write(11,'(1x,3(1pe14.7,1x))') eminph,emin,emax
      read(*,'(a100)') buffer
      write(11,*) buffer
      read(*,*) wcc,wcb
      write(11,'(1x,2(1pe14.7,1x))') wcc,wcb
      read(*,'(a100)') buffer
      write(11,*) buffer
      read(*,*) shigh,slow,ecross
      write(11,'(1x,3(1pe10.3,1x))') shigh,slow,ecross
      read(*,'(a100)') buffer
      write(11,*) buffer
      read(*,*) nomat
      write(11,'(1x,i3)') nomat
      read(*,*) buffer
      write(11,*) ' '

      do 10 i=1,nomat
        call getnam(5,matnam,len2)
        write(11,*) 'MATERIAL: ',matnam(1:len2)
        fname='_pendat/'//matnam(1:len2)
        open(10,file=fname)

c       *** Read material data; inimat() reads from unit 10 and writes to 11:
        call inimat(atno,atno2,atno21,mass,dens,excite,
     &              einf,esup,epinf,epsup)
        if (i.eq.1) then
          refzm = atno/mass
          refz2m = atno2/mass
          if (einf.gt.absmin) then
            write(*,*)
     &       'main:error: Missing low energy data in material file.'
            stop
          endif
        endif
        write(11,*) 'AtNo AtNo^2 to mass ratios with respect to ref:'
        write(11,'(2(1x,1pe14.7))') atno/mass/refzm,atno2/mass/refz2m

c       *** Elastic physics:
        call initot()
        if (i.eq.1) then
          call wstep(emin,emax,granul)
          fname = prefix(1:len)//'.step'
c         *** Reload and prepare interpolation:
          call rstep(fname,bytes)
        endif
        call wbw(emin,emax,granul)
        call wqsurf(emin,emax,granul)
        call wscpw(emin,emax,granul)

c       *** Inelastic physics:
        call iniine(atno,atno2,mass,dens,excite,wcc,wcb)
        if (i.eq.1) call wlammo(emin,emax,granul)
        call wlambr(emin,emax,granul)
        call wrstpw(emin,emax,granul)

c       *** Photon physics:
        call wlamph(eminph,emax,granul)
        call wicmpt(eminph,emax,granul)
        call wiphte(eminph,emax,granul)
        call wipair(eminph,emax,granul)
        write(11,*) ' '
        close(10)
 10   continue

      close(11)
      close(13)
      close(15)
      close(17)
      close(19)
      close(21)
      close(23)
      close(25)
      close(27)
      close(29)
      close(31)
      write(*,*) ' '
      write(*,*) ' '
      write(*,*) 'Have a nice day.'
      write(*,*) ' '
      stop
      end


      subroutine wstep(emin,emax,granul)
c*******************************************************************
c*    Writes scattering strength(E) to a file and examines         *
c*    interpolation accuracy                                       *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> initot() must be called before 1st call                 *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      character*20 prefix
      integer len
      common /cid/ prefix,len
      real*8 shigh,slow,ecross
      common /dpmpat/ shigh,slow,ecross

      integer ndata
      parameter (ndata=2**9)
      real*8 energy(ndata),patsp(ndata),patspa(ndata)
      real*8 patspb(ndata),patspc(ndata),patspd(ndata)

      character*40 fname
      integer i,ke
      real*8 le,le0,dle,e,avedif,maxdif,me,gle,ge
      real*8 fip,freal,dif,deltak

      le0 = emin
      dle = (emax-le0)/(ndata-1)
      le = le0
      do 100 i=1,ndata
        energy(i) = le
        e = le
        patsp(i) = deltak(e)
        le = le+dle
 100  continue

c     *** Checking accuracy inside mesh cells:
      call spline(energy,patsp,patspa,patspb,patspc,patspd,
     &            0.d0,0.d0,ndata)
      me = emin
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 150 i=1,ndata-1
        do 200 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = gle
          fip =
     &      patspa(i)+gle*(patspb(i)+gle*(patspc(i)+gle*patspd(i)))
          freal = deltak(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 200    continue
        le = le+dle
 150  continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      fname= prefix(1:len)//'.step'
      open(1,file=fname)
      write(1,*) 'This file is part of set:'
      write(1,*) prefix(1:len)
      write(1,*) 'Step parameters shigh(cm) slow(cm) Ecross(eV):'
      write(1,'(1x,3(1pe10.3,1x))') shigh,slow,ecross
      write(1,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(1,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(1,*) ' energy(eV) -- ScatStrength'
      do 300 i=1,ndata
        write(1,'(1x,2(1pe14.7,1x))') energy(i),patsp(i)
 300  continue
      write(1,*) ' '
      close(1)
      write(*,*) 'wstep: data written to file ',fname
      end


      subroutine wbw(emin,emax,granul)
c*******************************************************************
c*    Writes bw(E) to a file and examines interpolation accuracy   *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> initot() must be called before 1st call                 *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      character*20 prefix
      integer len
      common /cid/ prefix,len

      integer ndata,i,ke
      parameter (ndata=2**9)
      real*8 energy(ndata),bwsp(ndata),awsolv
      real*8 bwspa(ndata),bwspb(ndata),bwspc(ndata),bwspd(ndata)
      real*8 le0,dle,le,e,me,avedif,maxdif,gle,ge,fip,dif
      real*8 bw,ilamtt,dummy,path,G1,scptot,aw,accu,deltak,stepip
      parameter (accu=1.0d-10)

c     *** Preparing interpolation:
      write(*,*) 'wbw: loading array'
      le0 = -1.d0/emin
      dle = (-1.d0/emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        energy(i) = le
        e = -1.d0/le
        deltak = stepip(e)
        G1 = scptot(e)/ilamtt(e)
        path = deltak/G1
        aw = awsolv(G1,accu)
        call newpaw(path,aw,0)
        call spreaw(dummy,bw)
        bwsp(i) = bw
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      write(*,*) 'wbw: examining mesh'
      call spline(energy,bwsp,bwspa,bwspb,bwspc,bwspd,
     &            0.d0,0.d0,ndata)
      me = emin
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = -1.d0/gle
          fip = bwspa(i)+gle*(bwspb(i)+gle*(bwspc(i)+gle*bwspd(i)))
          deltak = stepip(ge)
          G1 = scptot(ge)/ilamtt(ge)
          path = deltak/G1
          aw = awsolv(G1,accu)
          call newpaw(path,aw,0)
          call spreaw(dummy,bw)
          dif = dabs(1.d0-fip/bw)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(29,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(29,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(29,*) ' energy(eV) -- bw'
      do 30 i=1,ndata
        write(29,'(1x,2(1pe14.7,1x))') -1.d0/energy(i),bwsp(i)
 30   continue
      write(29,*) ' '
      write(*,*) 'wbw: data written to unit 29'
      end


      subroutine wqsurf(emin,emax,granul)
c*******************************************************************
c*    Writes q(u;E) to a file and examines interpolation accuracy  *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> initot() must be called before 1st call                 *
c*      -> below e0, the scattering is considered to be isotropic  *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      character*20 prefix
      integer len
      common /cid/ prefix,len

      integer nu,ne,ku,ke,i,j
      parameter (nu=2**7,ne=2**8)
      real*8 q(nu,ne),idu,ilamtt,dummy
      real*8 le0,dle,le,du,e,bw,u,avedif,maxdif
      real*8 ole,ou,ouole,ge,gle,gu,mu,me,dif,fip,freal,qmax
      real*8 awsolv,accu,deltak,path,aw,G1,scptot
      parameter (accu=1.0d-10)
      real*8 stepip,qsurf

c     ** Preparing interpolation for q:
      write(*,*) 'wqsurf: loading array'
      le0 = -1.d0/emin
      dle = (-1.d0/emax-le0)/(ne-1)
      le = le0
      du = 1.d0/(nu-1)
      idu = 1.d0/du
      qmax = 0.d0
      do 10 i=1,ne
        e = -1.d0/le
        deltak = stepip(e)
        G1 = scptot(e)/ilamtt(e)
        path = deltak/G1
        aw = awsolv(G1,accu)
        call newpaw(path,aw,0)
        call spreaw(dummy,bw)
        u = 0.d0
        do 20 j=1,nu
          q(j,i) = qsurf(u,bw)
          if (q(j,i).gt.qmax) qmax = q(j,i)
          u = u+du
 20     continue
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      write(*,*) 'wqsurf: examining mesh'
      avedif = 0.d0
      maxdif = 0.d0
      le = le0
      do 30 i=1,ne-1
        do 15 ke=1,granul
          ole = ke/dble(granul+1)
          gle = le+ole*dle
          ge = -1.d0/gle
          deltak = stepip(ge)
          G1 = scptot(ge)/ilamtt(ge)
          path = deltak/G1
          aw = awsolv(G1,accu)
          call newpaw(path,aw,0)
          call spreaw(dummy,bw)
          u = 0.d0
          do 40 j=1,nu-1
            do 25 ku=1,granul
              ou = ku/dble(granul+1)
              gu = u+ou*du
              ouole = ou*ole
              fip = q(j,i)*(1.d0-ou-ole+ouole)+q(j+1,i)*(ou-ouole)+
     &                q(j,i+1)*(ole-ouole)+q(j+1,i+1)*ouole
              freal = qsurf(gu,bw)
              dif = dabs(1.d0-fip/freal)
              if (maxdif.lt.dif) then
                maxdif = dif
                mu = gu
                me = ge
              endif
              avedif = avedif+dif
 25         continue
          u = u+du
 40       continue
 15     continue
        le = le+dle
 30   continue
      avedif = 100.d0*avedif/((nu-1)*(ne-1)*granul**2)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(31,*)
     &  'nu,ne,granularity,mean_dif(%),max_dif(%) at{u,eV}:'
      write(31,'(1x,2(i5,1x),i3,1x,4(1pe10.3,1x))')
     &  nu,ne,granul,avedif,maxdif,mu,me
      write(31,*) 'qmax & effi'
      write(31,'(1x,2(1pe15.8,1x))') qmax,1.d0/qmax
      write(31,*) ' energy(eV); u -- q(u;energy)'
      le = le0
      do 50 i=1,ne
        e = -1.d0/le
        write(31,'(1x,1pe12.6)') e
        u = 0.d0
        do 60 j=1,nu
          write(31,'(1x,1pe12.6,1x,1pe10.4)') u,q(j,i)
          u = u+du
 60     continue
        le = le+dle
 50   continue
      write(31,*) ' '
      write(*,*) 'wqsurf: data written to unit 31'
      end


      subroutine wscpw(emin,emax,granul)
c*******************************************************************
c*    Writes inverse 1st TMFP to a file and examines               *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> initot() must be called before 1st call                 *
c*      -> outputs to unit 13, which must be already open; the unit*
c*         is not closed                                           *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      integer ndata,ke,i
      parameter (ndata=2**11)
      real*8 energy(ndata),scapw(ndata)
      real*8 scapwa(ndata),scapwb(ndata)
      real*8 le0,dle,le,e,me,avedif,maxdif,gle,ge,fip,freal,dif,scptot

c     *** Preparing interpolation:
      le0 = emin
      dle = (emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        e = le
        energy(i) = e
        scapw(i) = scptot(e)
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      do 40 i=1,ndata-1
        scapwb(i) = (scapw(i+1)-scapw(i))/(energy(i+1)-energy(i))
        scapwa(i) = scapw(i)-energy(i)*scapwb(i)
 40   continue

      me = emin
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = gle
          fip = scapwa(i)+gle*scapwb(i)
          freal = scptot(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(13,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(13,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(13,*) ' energy(eV) -- ScattPower(cm^2/g)'
      do 30 i=1,ndata
        write(13,'(1x,2(1pe14.7,1x))') energy(i),scapw(i)
 30   continue
      write(13,*) ' '
      write(*,*) 'wscpw: data written to unit 13'
      end


      subroutine wlammo(emin,emax,granul)
c*******************************************************************
c*    Writes hard inelastic mean free path to a file and examines  *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> iniion() or iniine() must be called before 1st call     *
c*      -> the actual Emin is set such that the MFP does not exceed*
c*         some value large enough to be considered as infinity    *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      character*20 prefix
      integer len
      common /cid/ prefix,len
      real*8 wcion,wcbre
      common /cutoff/ wcion,wcbre

      character*40 fname
      integer ndata,ke,i
      parameter (ndata=2**8)
      real*8 energy(ndata),lamsp(ndata)
      real*8 lamspa(ndata),lamspb(ndata),lamspc(ndata),lamspd(ndata)
      real*8 le0,dle,le,e,me,avedif,maxdif,gle,ge,fip,freal,lambmo,dif
      real*8 e0,winl,winh,r0,rang,elow,ehig,f,kcmax
      parameter (kcmax=0.4999999999d0)
      parameter (winl=10.d0,winh=11.d0)

c     *** Ensuring lambda_hard does not diverge at E0, but is large enough:
      e0 = emin
      r0 = rang(emax)
      if (lambmo(e0)/r0.lt.winh) goto 5
      if (lambmo(emax)/r0.gt.winh) goto 5
      elow = emin
      ehig = emax
 7    continue
        e0 = dsqrt(elow*ehig)
        f = lambmo(e0)/r0
        if (winl.le.f.and.f.le.winh) goto 5
        if (f.gt.winh) then
          elow = e0
        else
          ehig = e0
        endif
      goto 7
 5    continue

c     *** Preparing interpolation:
      le0 = -1.d0/e0
      dle = (-1.d0/emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        energy(i) = le
        e = -1.d0/le
        lamsp(i) = 1.d0/lambmo(e)
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      call spline(energy,lamsp,lamspa,lamspb,lamspc,lamspd,
     &            0.d0,0.d0,ndata)
      me = e0
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = -1.d0/gle
          fip = 1.d0/
     &      (lamspa(i)+gle*(lamspb(i)+gle*(lamspc(i)+gle*lamspd(i))))
          freal = lambmo(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      fname= prefix(1:len)//'.lammo'
      open(1,file=fname)
      write(1,*) 'This file is part of set:'
      write(1,*) prefix(1:len)
      write(1,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(1,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(1,*) ' energy(eV) -- lambda_mo(g/cm^2)'
      do 30 i=1,ndata
        write(1,'(1x,2(1pe14.7,1x))') -1.d0/energy(i),1.d0/lamsp(i)
 30   continue
      write(1,*) ' '
      close(1)
      write(*,*) 'wlammo: data written to file ', fname
      end


      subroutine wlambr(emin,emax,granul)
c*******************************************************************
c*    Writes hard radiative mean free path to a file and examines  *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> inibre() --or iniine()-- must be called previously      *
c*      -> the actual Emin is set such that the MFP does not exceed*
c*         some value large enough to be considered as infinity    *
c*      -> outputs to unit 27, which must be already open; the unit*
c*         is not closed                                           *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      character*20 prefix
      integer len
      common /cid/ prefix,len

      integer ndata,ke,i
      parameter (ndata=2**9)
      real*8 energy(ndata),lrasp(ndata)
      real*8 lraspa(ndata),lraspb(ndata)
      real*8 le0,dle,le,e,me,avedif,maxdif,gle,ge,fip,freal
      real*8 e0,winl,winh,r0,rang,elow,ehig,f,dif
      parameter (winl=10.d0,winh=11.d0)
      real*8 plambr

c     *** Assuring lambda_bre does not diverge at E0, but is large enough
      e0 = emin
      r0 = rang(emax)
      if (plambr(e0)/r0.lt.winh) goto 5
      if (plambr(emax)/r0.gt.winh) goto 5
      elow = emin
      ehig = emax
 7    continue
        e0 = dsqrt(elow*ehig)
        f = plambr(e0)/r0
        if (winl.le.f.and.f.le.winh) goto 5
        if (f.gt.winh) then
          elow = e0
        else
          ehig = e0
        endif
      goto 7
 5    continue

c     *** Preparing interpolation:
      le0 = -1.d0/e0
      dle = (-1.d0/emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        energy(i) = le
        e = -1.d0/le
        lrasp(i) = 1.d0/plambr(e)
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      do 40 i=1,ndata-1
        lraspb(i) = (lrasp(i+1)-lrasp(i))/(energy(i+1)-energy(i))
        lraspa(i) = lrasp(i)-energy(i)*lraspb(i)
 40   continue

      me = e0
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = -1.d0/gle
          fip = 1.d0/(lraspa(i)+gle*lraspb(i))
          freal = plambr(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(27,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(27,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(27,*) ' energy(eV) -- lambda_rad_hard(g/cm^2)'
      do 30 i=1,ndata
        write(27,'(1x,2(1pe14.7,1x))') -1.d0/energy(i),1.d0/lrasp(i)
 30   continue
      write(27,*) ' '
      write(*,*) 'wlambr: data written to unit 27'
      end


      subroutine wrstpw(emin,emax,granul)
c*******************************************************************
c*    Writes restricted stopping power to a file and examines      *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> inimat() must be called previously                      *
c*      -> iniion() or iniine() must be called before 1st call     *
c*      -> outputs to units 15 and 25, which must be already open; *
c*         units are not closed                                    *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      real*8 BCOR,GAM,EPCUT,F0,BCB
      COMMON/PBREMC/BCOR,GAM,EPCUT,F0(4),BCB

      integer ndata,ke,i
      parameter (ndata=2**10)
      real*8 energy(ndata),rstpw(ndata)
      real*8 rstpwa(ndata),rstpwb(ndata)
      real*8 le0,dle,le,e,me,avedif,maxdif,gle,ge,fip,freal
      real*8 stpmo,dif,pstpbr,cstpow,rstpow

c     *** Preparing interpolation:
      le0 = emin
      dle = (emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        e = le
        energy(i) = e
        rstpw(i) = cstpow(e)+rstpow(e)-stpmo(e)-pstpbr(e)
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      do 40 i=1,ndata-1
        rstpwb(i) = (rstpw(i+1)-rstpw(i))/(energy(i+1)-energy(i))
        rstpwa(i) = rstpw(i)-energy(i)*rstpwb(i)
 40   continue
      me = emin
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = gle
          fip = rstpwa(i)+gle*rstpwb(i)
          freal = cstpow(ge)+rstpow(ge)-stpmo(ge)-pstpbr(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(15,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(15,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(15,*) ' energy(eV) -- Res_StopPower(eV*cm^2/g)'
      do 30 i=1,ndata
        write(15,'(1x,2(1pe14.7,1x))') energy(i),rstpw(i)
 30   continue
      write(15,*) ' '
      write(*,*) 'wrstpw: data written to unit 15'
      write(25,*) ' '
      write(25,*) f0(1),f0(2),f0(3),bcb
      write(*,*) 'wrstpw: data written to unit 25'
      end


      subroutine wlamph(emin,emax,granul)
c*******************************************************************
c*    Writes the photon inverse total mean free path to a file     *
c*    and examines                                                 *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> inimat() must be called previously                      *
c*      -> outputs to unit 17, which must be already open; the unit*
c*         is not closed                                           *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      integer ndata,ke,i
      parameter (ndata=2**11)
      real*8 energy(ndata),lamph(ndata)
      real*8 lampha(ndata),lamphb(ndata),lamphc(ndata),lamphd(ndata)
      real*8 le0,dle,le,e,me,avedif,maxdif,gle,ge,fip,freal,dif
      real*8 icompt,iphote,ipairp

c     *** Preparing interpolation:
      le0 = emin
      dle = (emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        energy(i) = le
        e = le
        lamph(i) = icompt(e)+iphote(e)+ipairp(e)
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      call spline(energy,lamph,lampha,lamphb,lamphc,lamphd,
     &            0.d0,0.d0,ndata)
      me = emin
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = gle
          fip=lampha(i)+gle*(lamphb(i)+gle*(lamphc(i)+gle*lamphd(i)))
          freal = icompt(ge)+iphote(ge)+ipairp(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(17,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(17,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(17,*) ' energy(eV) -- Lambda^-1(cm^2/g)'
      do 30 i=1,ndata
        write(17,'(1x,2(1pe14.7,1x))') energy(i),lamph(i)
 30   continue
      write(17,*) ' '
      write(*,*) 'wilaph: data written to unit 17'
      end


      subroutine wicmpt(emin,emax,granul)
c*******************************************************************
c*    Writes the inverse Compton mean free path to a file          *
c*    and examines                                                 *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> inimat() must be called previously                      *
c*      -> outputs to unit 19, which must be already open; the unit*
c*         is not closed                                           *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      integer ndata,ke,i
      parameter (ndata=2**8)
      real*8 energy(ndata),lamph(ndata)
      real*8 lampha(ndata),lamphb(ndata),lamphc(ndata),lamphd(ndata)
      real*8 le0,dle,le,e,icompt,me,avedif,maxdif,gle,ge,fip,freal,dif

c     *** Preparing interpolation:
      le0 = emin
      dle = (emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        energy(i) = le
        e = le
        lamph(i) = icompt(e)
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      call spline(energy,lamph,lampha,lamphb,lamphc,lamphd,
     &            0.d0,0.d0,ndata)
      me = emin
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = gle
          fip=lampha(i)+gle*(lamphb(i)+gle*(lamphc(i)+gle*lamphd(i)))
          freal = icompt(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(19,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(19,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(19,*) ' energy(eV) -- Lambda^-1(cm^2/g)'
      do 30 i=1,ndata
        write(19,'(1x,2(1pe14.7,1x))') energy(i),lamph(i)
 30   continue
      write(19,*) ' '
      write(*,*) 'wicmpt: data written to unit 19'
      end


      subroutine wiphte(emin,emax,granul)
c*******************************************************************
c*    Writes the inverse photoelectric mean free path to a file    *
c*    and examines                                                 *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> inimat() must be called previously                      *
c*      -> outputs to unit 21, which must be already open; the unit*
c*         is not closed                                           *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      integer ndata,ke,i
      parameter (ndata=2**12)
      real*8 energy(ndata),lamph(ndata)
      real*8 lampha(ndata),lamphb(ndata),lamphc(ndata),lamphd(ndata)
      real*8 le0,dle,le,e,iphote,me,avedif,maxdif,gle,ge,fip,freal,dif

c     *** Preparing interpolation:
      le0 = emin
      dle = (emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        energy(i) = le
        e = le
        lamph(i) = iphote(e)
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      call spline(energy,lamph,lampha,lamphb,lamphc,lamphd,
     &            0.d0,0.d0,ndata)
      me = emin
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = gle
          fip=lampha(i)+gle*(lamphb(i)+gle*(lamphc(i)+gle*lamphd(i)))
          freal = iphote(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(21,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(21,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(21,*) ' energy(eV) -- Lambda^-1(cm^2/g)'
      do 30 i=1,ndata
        write(21,'(1x,2(1pe14.7,1x))') energy(i),lamph(i)
 30   continue
      write(21,*) ' '
      write(*,*) 'wiphte: data written to unit 21'
      end


      subroutine wipair(emin,emax,granul)
c*******************************************************************
c*    Writes the inverse pair production mean free path to a file  *
c*    and examines                                                 *
c*                                                                 *
c*    Input:                                                       *
c*      {emin,emax} -> energy interval considered (eV)             *
c*      granul -> granularity to be used to examine the mesh       *
c*    Comments:                                                    *
c*      -> inimat() must be called previously                      *
c*      -> outputs to unit 23, which must be already open; the unit*
c*         is not closed                                           *
c*      -> only values well above threshold are written            *
c*******************************************************************
      implicit none
      integer granul
      real*8 emin,emax

      integer ndata,ke,i
      parameter (ndata=2**10)
      real*8 energy(ndata),lamph(ndata)
      real*8 lampha(ndata),lamphb(ndata),lamphc(ndata),lamphd(ndata)
      real*8 le0,dle,le,e,ipairp,me,avedif,maxdif,gle,ge,fip,freal,dif

c     *** Preparing interpolation:
      if (emin.gt.1024.d3) then
        le0 = emin
      else
        le0 = 1024.d3
      endif
      dle = (emax-le0)/(ndata-1)
      le = le0
      do 10 i=1,ndata
        energy(i) = le
        e = le
        lamph(i) = ipairp(e)
        le = le+dle
 10   continue

c     *** Checking accuracy inside mesh cells:
      call spline(energy,lamph,lampha,lamphb,lamphc,lamphd,
     &            0.d0,0.d0,ndata)
      me = emin
      avedif = 0.d0
      maxdif = 0.d0
      le = energy(1)
      do 15 i=1,ndata-1
        do 20 ke=1,granul
          gle = le+ke*dle/(granul+1)
          ge = gle
          fip=lampha(i)+gle*(lamphb(i)+gle*(lamphc(i)+gle*lamphd(i)))
          freal = ipairp(ge)
          dif = dabs(1.d0-fip/freal)
          if (maxdif.lt.dif) then
            maxdif = dif
            me = ge
          endif
          avedif = avedif+dif
 20     continue
        le = le+dle
 15   continue
      avedif = 100.d0*avedif/((ndata-1)*granul)
      maxdif = 100.d0*maxdif

c     *** Writing data to file:
      write(23,*) 'ndata,granularity,mean_dif(%),max_dif(%) at(eV):'
      write(23,'(1x,i5,1x,i3,1x,3(1pe10.3,1x))')
     &  ndata,granul,avedif,maxdif,me
      write(23,*) ' energy(eV) -- Lambda^-1(cm^2/g)'
      do 30 i=1,ndata
        write(23,'(1x,2(1pe14.7,1x))') energy(i),lamph(i)
 30   continue
      write(23,*) ' '
      write(*,*) 'wipair: data written to unit 23'
      end


      subroutine rstep(fname,bytes)
c*******************************************************************
c*    Reads scattering strength data and sets up interpolation     *
c*    matrices                                                     *
c*                                                                 *
c*    Input:                                                       *
c*      fname -> input file name                                   *
c*    Output:                                                      *
c*      bytes -> memory filled up by interpolation arrays          *
c*    Comments:                                                    *
c*      -> imported from dpm.f                                     *
c*******************************************************************
      implicit none
      character*40 fname
      integer bytes

      integer nscsr
      parameter (nscsr=2**9)
      real*8 escsr,scssp,scsspa,scsspb,scsspc,scsspd,idless
      common /dpmscsr/ escsr(nscsr),scssp(nscsr),
     & scsspa(nscsr),scsspb(nscsr),scsspc(nscsr),scsspd(nscsr),idless

      character*100 buffer
      integer i,ndata

      write(*,*) 'rstep: reading ',fname
      open(1,file=fname)
      read(1,'(a100)') buffer
      read(1,'(a100)') buffer
      read(1,'(a100)') buffer
      read(1,'(a100)') buffer
      read(1,'(a100)') buffer
      read(1,*) ndata
      if (ndata.ne.nscsr) then
        write(*,*) 'rstep Error: array dim do not match:'
        write(*,'(1x,2(i5,1x))') ndata,nscsr
        stop
      endif
      read(1,'(a100)') buffer
c     *** Prepare interpolation:
      do 20 i=1,nscsr
        read(1,*) escsr(i),scssp(i)
 20   continue
      close(1)

      idless = (nscsr-1)/(escsr(nscsr)-escsr(1))
      call spline(escsr,scssp,scsspa,scsspb,scsspc,scsspd,
     &  0.d0,0.d0,nscsr)
      bytes = 8*(6*nscsr)
      end


      real*8 function stepip(e)
c*******************************************************************
c*    3spline interpolation for scattering strength as a function  *
c*    of kinetic energy; this quantity is related to the step      *
c*    length                                                       *
c*                                                                 *
c*    Input:                                                       *
c*      e -> kinetic energy in eV                                  *
c*    Output:                                                      *
c*      K = scattering strength = integ{ds/lambda1(s)}             *
c*    Comments:                                                    *
c*      -> init() must be called before first call                 *
c*******************************************************************
      implicit none
      real*8 e

      integer nscsr
      parameter (nscsr=2**9)
      real*8 escsr,scssp,scsspa,scsspb,scsspc,scsspd,idless
      common /dpmscsr/ escsr(nscsr),scssp(nscsr),
     & scsspa(nscsr),scsspb(nscsr),scsspc(nscsr),scsspd(nscsr),idless

      integer i

      i = idless*(e-escsr(1))+1
      stepip = scsspa(i)+e*(scsspb(i)+e*(scsspc(i)+e*scsspd(i)))
      end


      real*8 function deltak(energy)
c*******************************************************************
c*    Scattering strength allowed for a step as a function of the *
c*    energy.                                                      *
c*                                                                 *
c*    Input:                                                       *
c*      energy -> kinetic energy in eV                             *
c*    Output:                                                      *
c*      -> scattering strength DeltaK.                             *
c*    Comments:                                                    *
c*      -> inimat() must be called before first call               *
c*      -> if energy is set to zero, prints on unit                *
c*         1 the scheme used to get the path                       *
c*******************************************************************
      implicit none
      real*8 energy

      real*8 shigh,slow,ecross
      common /dpmpat/ shigh,slow,ecross

      real*8 pi,ipi,arg,glue,scptot,sharp
      parameter (pi=3.1415926535897932d0,ipi=1.0d0/pi,sharp=5.0d0)

      if (energy.eq.0.0d0) then
        write(1,*) 'deltak: Using shigh,slow,ecross scheme.'
        return
      endif

c     *** Connect smoothly (in log scale) the high and low-E step
c       * lengths at Ecross:
c       * K(E) = lambda1^-1(E) * slow * (shigh/slow)^f(log(E/Ecross))
c       * where f(x) is chosen so that varies smoothly between 0 and 1,
c       * f(x) = arctg(sharp*x)/pi + 1/2,  with sharp a parameter.
      arg = dlog(energy/ecross)
      glue = ipi*datan(sharp*arg)+0.5d0
      deltak = scptot(energy)*slow*(shigh/slow)**glue
      end


c* end of file *****************************************************

